#include <avr/io.h>
#include <avr/pgmspace.h>

/*
void uart_send(const uint8_t *data, size_t n)
{
	while (n--) {
		while (!UCSR0A & (1<<UDRE0));
		UDR0 = *data++;
	}
}
*/


void uart_write(uint8_t c)
{
	while (!UCSR0A & (1<<UDRE0));
	UDR0 = c;
}


uint16_t readCoreTemperature()
{
	ADMUX |= (1<<REFS1)|(1<<REFS0);	// select 1.1V reference
	ADMUX |= (1<<MUX3);
	ADMUX &= ~((1<<MUX2)|(1<<MUX1)|(1<<MUX0));
	ADCSRA |= (1<<ADEN);	// enable ADC
	ADCSRA |= (1<<ADSC);	// start conversion
	while ((ADCSRA & (1<<ADIF)) == 0);	// wait for conversion to complete
	uint16_t r;
	r = ADCH << 8;
	r |= ADCL;
	return r;
}

void send(EmbeddedSystem *es)
{
	//uint8_t buf[128];
	//assert(es->calcSize() < sizeof(buf));
	es->toWire(uart_write);
	//uart_send(buf,n);
}


int main()
{
	EmbeddedSystem es;
	es.set_name(PSTR("balkon-sensor"));
	es.set_system(PSTR("avrp1"));
	es.set_revision(PSTR("V1.0"));
	Sensor_AD_16Bit *a0 = es.add_ad_16bit();
	a0->set_name(PSTR("core temperature"));
	while (1) {
		a0->set_value(readCoreTemperature());
		send(&es);
	}
}
