#include <stdint.h>

void send_varint16_0(void (*put)(uint8_t), uint16_t v)
{
	if (v & (1 << ((sizeof(v)*8)-1))) {
		unsigned padding = 9-sizeof(v)*8/7;
		do
			put(0xff);
		while (--padding);
	}
	do {
		uint8_t u8 = v & 0x7f;
		v >>= 7;
		if (v)
			u8 |= 0x80;
		put(u8);
	} while (v);
}

void send_varint16_1(void (*put)(uint8_t), uint16_t v)
{
	if (v & (1 << 15)) {
		unsigned padding = 9-sizeof(v)*8/7;
		do
			put(0xff);
		while (--padding);
	}
	do {
		uint8_t u8 = v & 0x7f;
		v >>= 7;
		if (v)
			u8 |= 0x80;
		put(u8);
	} while (v);
}

void send_varint16_2(void (*put)(uint8_t), uint16_t v)
{
	if ((int16_t)v < 0) {
		unsigned padding = 9-sizeof(v)*8/7;
		do
			put(0xff);
		while (--padding);
	}
	do {
		uint8_t u8 = v & 0x7f;
		v >>= 7;
		if (v)
			u8 |= 0x80;
		put(u8);
	} while (v);
}

